//+------------------------------------------------------------------+
//|                                                      ProjectName |
//|                                      Copyright 2012, CompanyName |
//|                                       http://www.companyname.net |
//+------------------------------------------------------------------+
/*
           iMA:
double iCustom(
   string symbol,       //    (NULL- )
   int timeframe,       // - (0- )
   "iFMA",              //   
   double period,       //  MA; .. (>1)    - (<1)
   double ma_shift,     //  MA; ..  (>0)
   int ma_method,       //  :
                           // 0- SMA (),
                           // 1- EMA (),
                           // 2- SSMA (),
                           // 3- LWMA (-)
   int applied_price,   //   :
                           // 0- Close, 1- Open, 2- High, 3- Low, 
                           // 4- Middle=(High+Low)/2 (),
                           // 5- Typical=(High+Low+Close)/3 (),
                           // 6- Weighted=High+Low+2*Close)/4 (),
                           // 7- Volume ()
   0,                   // mode -    (0)
   int shift            // 
   ) 

==============

iCustom(NULL,0,"iFMA",MAperiod,Shift,Method,Price, 0,i);
*/

#property indicator_chart_window //   
#property indicator_buffers 3
#property indicator_color1 Red  

//  
extern double MAperiod=3;
extern double Shift=0;
extern int Method=0;
extern int Price=0;
int History=0; // 0-  

double MA[],b0[],b1[]; //  .   
double k0,k1,period; // . EMA   
double rt; //   
int per; //   
double rts0,rts1; //      
int pers; //   
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
// 
void init()
  {
   if(MAperiod>1) {k0=2/(1+MAperiod); period=MAperiod;}
   else {k0=MAperiod; period=(2-MAperiod)/MAperiod;}
   k1=1-k0;

   per=MathFloor(period);
   rt=period-per;
   pers=MathFloor(Shift);
   rts1=Shift-pers; rts0=1-rts1;

   string _sn=_method(Method)+"("+DoubleToStr(period,2)+")";
   IndicatorShortName(_sn);

   SetIndexBuffer(0,MA); // 
   SetIndexLabel(0,_sn);
   SetIndexEmptyValue(0,0.0);
   SetIndexBuffer(1,b0); //  
   SetIndexStyle(1,DRAW_NONE);
   SetIndexLabel(1,NULL);
   SetIndexEmptyValue(1,0.0);
   SetIndexBuffer(2,b1); //  
   SetIndexStyle(2,DRAW_NONE);
   SetIndexLabel(2,NULL);
   SetIndexEmptyValue(2,0.0);

   ArrayInitialize(MA,0.0);
   ArrayInitialize(b0,0.0);
   ArrayInitialize(b1,0.0);

  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
void start()
  {
/*int limit=Bars-IndicatorCounted()-1;
   if(limit>1) 
     {
      limit=Bars-1;
      ArrayInitialize(MA,0.0);
      ArrayInitialize(b0,0.0);
      ArrayInitialize(b1,0.0);
     }
*/
//   if(History!=0 && limit>History) limit=History-1; // -   
//                                                    //  

   int counted_bars=IndicatorCounted();
   if(counted_bars<0) return(-1);
   if(counted_bars>0) counted_bars--;
   int limit=Bars-counted_bars;
   if(counted_bars==0) limit-=1+per;

   for(int i=limit; i>=0; i--)
     {
      double ma=0,mp=0;
      switch(Method)
        {
         case 0: // SMA
            int lim=limit-per-(rt>0)+1;
            if(i<=lim || i<2)
              { //  
               int j=i+per; //    
               if(i==lim)
                 { //  
                  ma=rt*Price(Price,j); //    
                  j--;
                  for(; j>=i; j--) ma+=Price(Price,j); //   
                 }
               else
                 { //  
                  if(rt>0) ma=b0[i+1]*period-rt*Price(Price,j+1)-(1-rt)*Price(Price,j)+Price(Price,i);
                  else ma=b0[i+1]*period-Price(Price,j)+Price(Price,i);
                 }
               b0[i]=ma/period; // MA
              }
            break;
         case 1: // EMA
            if(i==limit && i>1) ma=Price(Price,i); //  
            else ma=k0*Price(Price,i)+k1*b0[i+1]; //  
            b0[i]=ma;
            break;
         case 2: // SMMA
            lim=limit-per-(rt>0)+1;
            if(i<=lim || i<2)
              { //  
               if(i==lim)
                 { //  
                  j=i+per; //    
                  ma=rt*Price(Price,j); //    
                  j--;
                  for(; j>=i; j--) ma+=Price(Price,j); //   
                  ma/=period;
                 }
               else ma=((period-1)*b0[i+1]+Price(Price,i))/period; //  
              }
            b0[i]=ma; // MA
            break;
         case 3: // LWMA
            static double wt;
            lim=limit-per-(rt>0)+1;
            j=i+per; //    
            if(i<=lim || i<2)
              { //  
               if(i==lim)
                 { //  
                  if(rt>0)
                    {
                     ma=rt*Price(Price,j); //    
                     mp=ma; wt=rt;
                    }
                  else {wt=0; ma=0; mp=0;}
                  j--;
                  for(int k=1; j>=i; j--,k++)
                    { //    
                     ma+=Price(Price,j)*k;
                     mp+=Price(Price,j);
                     wt+=k;
                    }
                 }
               else
                 { //  
                  if(rt>0)
                    {
                     ma=b0[i+1]*wt-b1[i+1]+rt*Price(Price,j)+per*Price(Price,i);
                     mp=b1[i+1]-rt*Price(Price,j+1)-(1-rt)*Price(Price,j)+Price(Price,i);
                    }
                  else
                    {
                     ma=b0[i+1]*wt-b1[i+1]+per*Price(Price,i);
                     mp=b1[i+1]-Price(Price,j)+Price(Price,i);
                    }
                 }
               b0[i]=ma/wt; b1[i]=mp;// MA
              }
        }
      //  ( )
      double b01=b0[i+pers+1];
      if(b01!=0 || rts1==0) MA[i]=rts1*b01+rts0*b0[i+pers];
     }
  }
//  
double Price(int ApplPrice,int i)
  {
   switch(ApplPrice)
     {
      case 0: return(Close[i]);
      case 1: return(Open[i]);
      case 2: return(High[i]);
      case 3: return(Low[i]);
      case 4: return((High[i]+Low[i])/2); // Middle
      case 5: return((High[i]+Low[i]+Close[i])/3); // Typical
      case 6: return((High[i]+Low[i]+2*Close[i])/4); // Weighted
      case 7: return(Volume[i]);
      default: return(Close[i]);
     }
  }
//  
string _method(int m)
  {
   switch(m)
     {
      case 0: return("SMA"); // SMA
      case 1: return("EMA"); // EMA
      case 2: return("SMMA"); // SMMA
      case 3: return("LWMA"); // LWMA
      default: return("SMA");
     }
  }
//+------------------------------------------------------------------+
